#include <opencv2/opencv.hpp>
#include <opencv2/core.hpp>
#include <opencv2/imgcodecs.hpp>
#include <opencv2/video/tracking.hpp>

using namespace std;
using namespace cv;

#ifndef POSTPROCESSD__STACKERCPP_H
#define POSTPROCESSD__STACKERCPP_H

class Stacker {
public:
        Stacker();

        void
        add_frame(unsigned char *data, int width, int height);

        char *
        get_result();

        char *
        postprocess(unsigned char *data, int width, int height);

private:
        int layers;
        cv::Mat reference;
        cv::Mat stacked;
        clock_t stopwatch;

        Mat
        postprocess_mat(Mat input);

        void
        stopwatch_start();

        void
        stopwatch_mark(const char *name);
};

#endif //POSTPROCESSD__STACKERCPP_H
